/*
		redit.cpp : implementation file

        Copyright (C) 2000 Patrick Dughi

        This software may be used and distributed according to the terms
        of the GNU Public License, incorporated herein by reference, located
		as the file gpl.txt in this same directory.

        The author may be reached at dughi@imaxx.net.
.		
		Primary control dialog for the redit window.
*/
#pragma warning(disable:4786)
#include <vector>
#include <map>
#include <string>
#include "stdafx.h"
#include "Cbreak.h"
#include "Redit.h"
#include "utils.h"
#include "EditDoor.h"
#include "JumpToRoom.h"
#include "ExdescAdd.h"
#include "NewRoom.h"
#include "BitvectorSel.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#pragma warning(disable:4786)

extern CCbreakApp theApp;

/////////////////////////////////////////////////////////////////////////////
// Redit property page

IMPLEMENT_DYNCREATE(Redit, CPropertyPage)

extern World the_world;

Redit::Redit() : CPropertyPage(Redit::IDD)
{
	//{{AFX_DATA_INIT(Redit)
	m_room_description = _T("");
	m_exdesc_string = _T("");
	m_reset_mode = -1;
	m_sector_type = -1;
	m_zone_lifespan = 0;
	m_zone_name = _T("");
	m_zone_range = _T("");
	m_room_name = _T("");
	m_zone_number = 0;
	//}}AFX_DATA_INIT
	
}

Redit::~Redit()
{
}

void Redit::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(Redit)
	DDX_Control(pDX, IDC_ROOM_NAME, e_room_name);
	DDX_Control(pDX, IDC_EXDESC_DESC, e_exdesc_string);
	DDX_Control(pDX, IDC_EDIT_ROOMDESC, e_room_description);
	DDX_Control(pDX, ID_ZONE_NAME, e_zone_name);
	DDX_Control(pDX, IDC_DOOR_W, m_door_w);
	DDX_Control(pDX, IDC_DOOR_UP, m_door_u);
	DDX_Control(pDX, IDC_DOOR_SW, m_door_sw);
	DDX_Control(pDX, IDC_DOOR_SE, m_door_se);
	DDX_Control(pDX, IDC_DOOR_S, m_door_s);
	DDX_Control(pDX, IDC_DOOR_NW, m_door_nw);
	DDX_Control(pDX, IDC_DOOR_NE, m_door_ne);
	DDX_Control(pDX, IDC_DOOR_N, m_door_n);
	DDX_Control(pDX, IDC_DOOR_E, m_door_e);
	DDX_Control(pDX, IDC_DOOR_DOWN, m_door_d);
	DDX_Control(pDX, ID_ROOM_NUMBER, m_room_number);
	DDX_Text(pDX, IDC_EDIT_ROOMDESC, m_room_description);
	DDX_Text(pDX, IDC_EXDESC_DESC, m_exdesc_string);
	DDX_CBIndex(pDX, IDC_RESET_MODE, m_reset_mode);
	DDX_CBIndex(pDX, IDC_SECTOR_TYPE, m_sector_type);
	DDX_Text(pDX, ID_ZONE_LIFESPAN, m_zone_lifespan);
	DDX_Text(pDX, ID_ZONE_NAME, m_zone_name);
	DDX_Text(pDX, ID_ZONE_RANGE, m_zone_range);
	DDX_Text(pDX, IDC_ROOM_NAME, m_room_name);
	DDX_Text(pDX, ID_ZONE_NUMBER, m_zone_number);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(Redit, CPropertyPage)
	//{{AFX_MSG_MAP(Redit)
	ON_CBN_SELCHANGE(IDC_EXDESC_KEYWORD, OnSelchangeExdescKeyword)
	ON_BN_CLICKED(ID_ROOM_NUMBER, OnRoomNumber)
	ON_BN_CLICKED(ID_NEXT_ROOM, OnNextRoom)
	ON_BN_CLICKED(ID_PREVIOUS_ROOM, OnPreviousRoom)
	ON_BN_CLICKED(ID_PREVIOUS_ZONE, OnPreviousZone)
	ON_BN_CLICKED(ID_NEXT_ZONE, OnNextZone)
	ON_BN_CLICKED(IDC_NEW_DESC, OnNewDesc)
	ON_EN_CHANGE(IDC_EXDESC_DESC, OnChangeExdescDesc)
	ON_EN_CHANGE(IDC_ROOM_NAME, OnChangeRoomName)
	ON_CBN_SELCHANGE(IDC_SECTOR_TYPE, OnEditchangeSectorType)
	ON_EN_CHANGE(IDC_EDIT_ROOMDESC, OnChangeEditRoomdesc)
	ON_EN_CHANGE(ID_ZONE_NAME, OnChangeZoneName)
	ON_EN_CHANGE(ID_ZONE_LIFESPAN, OnChangeZoneLifespan)
	ON_CBN_SELCHANGE(IDC_RESET_MODE, OnEditchangeResetMode)
	ON_EN_CHANGE(ID_ZONE_RANGE, OnChangeZoneRange)
	ON_BN_CLICKED(IDC_DELETE_DESC, OnDeleteDesc)
	ON_BN_CLICKED(IDC_DOOR_UP, OnDoorUp)
	ON_BN_CLICKED(IDC_DOOR_NW, OnDoorNw)
	ON_BN_CLICKED(IDC_DOOR_NE, OnDoorNe)
	ON_BN_CLICKED(IDC_DOOR_N, OnDoorN)
	ON_BN_CLICKED(IDC_DOOR_W, OnDoorW)
	ON_BN_CLICKED(IDC_DOOR_E, OnDoorE)
	ON_BN_CLICKED(IDC_DOOR_S, OnDoorS)
	ON_BN_CLICKED(IDC_DOOR_SW, OnDoorSw)
	ON_BN_CLICKED(IDC_DOOR_DOWN, OnDoorDown)
	ON_BN_CLICKED(IDC_DOOR_SE, OnDoorSe)
	ON_BN_CLICKED(IDC_ROOM_FLAGS, OnRoomFlags)
	ON_BN_CLICKED(IDC_SAVE_ROOM, OnSaveRoom)
	ON_BN_CLICKED(IDC_DELETE_ROOM, OnDeleteRoom)
	ON_BN_CLICKED(IDC_NEW_ROOM, OnNewRoom)
	ON_BN_CLICKED(IDC_GOTO_ZCMDS, OnGotoZcmds)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// Redit message handlers

BOOL Redit::OnInitDialog() 
{
	CPropertyPage::OnInitDialog();
	

	if(!are_there_zones()) {
    disable_redit(-1);
	} else if (the_world.mob_list.empty()) {
		disable_redit(0);
	} else {
		disable_redit(1);
  }	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

extern World the_world;
extern CDirDialog ourlib;

void Redit::LoadRedit()
{
  int room_vnum;
  vector<Ex_Desc_Data>::const_iterator exd;
  Room *lroom;
  room_vnum= theApp.dlg->current_room;

  /* only have to do this for redit, because redit is activated as the first panel, before
     we load our data! */

  if(!are_there_zones()) {
    disable_redit(-1);
	} else if (the_world.room_list.empty()) {
		disable_redit(0);
	} else {
		disable_redit(1);
  }	
  if(room_vnum < 0) {
	  return ;
  }

  	if(!the_world.more_doors) {
	  m_door_ne.ShowWindow(SW_HIDE);
	  m_door_nw.ShowWindow(SW_HIDE);
	  m_door_se.ShowWindow(SW_HIDE);
	  m_door_sw.ShowWindow(SW_HIDE);
		GetDlgItem(IDC_STATICNW)->ShowWindow(SW_HIDE);
		GetDlgItem(IDC_STATICNE)->ShowWindow(SW_HIDE);
		GetDlgItem(IDC_STATICSW)->ShowWindow(SW_HIDE);
		GetDlgItem(IDC_STATICSE)->ShowWindow(SW_HIDE);
	}

  lroom = &(the_world.room_list[room_vnum]);

  m_room_name=lroom->name.c_str();
  m_room_number.SetWindowText(iprintf("%d",lroom->number));
  m_sector_type=lroom->sector_type;
  m_room_description=lroom->description.c_str();
  m_exdesc_string = "";
	((CComboBox *) GetDlgItem(IDC_EXDESC_KEYWORD))->ResetContent();
  
	if(!lroom->exdesc.empty()) {
    for(exd = lroom->exdesc.begin();exd != lroom->exdesc.end();exd++) {
	   ((CComboBox *) GetDlgItem(IDC_EXDESC_KEYWORD))->AddString(exd->keyword.c_str());
		}
		exd=lroom->exdesc.begin();
	  ((CComboBox *) GetDlgItem(IDC_EXDESC_KEYWORD))->SelectString(-1,exd->keyword.c_str());
	  m_exdesc_string = exd->desc.c_str();

	}

  m_zone_number = the_world.zone_list[lroom->zone].number;
	m_zone_lifespan=the_world.zone_list[lroom->zone].lifespan;
	m_reset_mode=the_world.zone_list[lroom->zone].reset_mode;
	m_zone_name=the_world.zone_list[lroom->zone].name.c_str();
	m_zone_range=iprintf("%d-%d",the_world.zone_list[lroom->zone].number *100,
		the_world.zone_list[lroom->zone].top);

 
  if(!lroom->exdesc.size()) {
	  ((CEdit *) GetDlgItem(IDC_EXDESC_DESC))->SetReadOnly(TRUE);
		GetDlgItem(IDC_EXDESC_KEYWORD)->EnableWindow(FALSE);
  } else {
	  ((CEdit *) GetDlgItem(IDC_EXDESC_DESC))->SetReadOnly(FALSE);
		GetDlgItem(IDC_EXDESC_KEYWORD)->EnableWindow(TRUE);
  }

	/* churrah! Doors! */

  if(!the_world.more_doors) {
	  m_door_ne.ShowWindow(SW_HIDE);
	  m_door_nw.ShowWindow(SW_HIDE);
	  m_door_se.ShowWindow(SW_HIDE);
	  m_door_sw.ShowWindow(SW_HIDE);
		GetDlgItem(IDC_STATICNW)->ShowWindow(SW_HIDE);
		GetDlgItem(IDC_STATICNE)->ShowWindow(SW_HIDE);
		GetDlgItem(IDC_STATICSW)->ShowWindow(SW_HIDE);
		GetDlgItem(IDC_STATICSE)->ShowWindow(SW_HIDE);
  } else {
	  m_door_ne.ShowWindow(SW_SHOW);
	  m_door_nw.ShowWindow(SW_SHOW);
	  m_door_se.ShowWindow(SW_SHOW);
	  m_door_sw.ShowWindow(SW_SHOW);
		GetDlgItem(IDC_STATICNW)->ShowWindow(SW_SHOW);
		GetDlgItem(IDC_STATICNE)->ShowWindow(SW_SHOW);
		GetDlgItem(IDC_STATICSW)->ShowWindow(SW_SHOW);
		GetDlgItem(IDC_STATICSE)->ShowWindow(SW_SHOW);
	}

  if(lroom->direction_data[0].target_room >= 0) {
    m_door_n.SetWindowText(iprintf("%d",lroom->direction_data[0].target_room));
	} else {
		m_door_n.SetWindowText("None");
	}

  if(lroom->direction_data[1].target_room >= 0) {
    m_door_e.SetWindowText(iprintf("%d",lroom->direction_data[1].target_room));
	} else {
		m_door_e.SetWindowText("None");
	}

  if(lroom->direction_data[2].target_room >= 0) {
    m_door_s.SetWindowText(iprintf("%d",lroom->direction_data[2].target_room));
	} else {
		m_door_s.SetWindowText("None");
	}

  if(lroom->direction_data[3].target_room >= 0) {
    m_door_w.SetWindowText(iprintf("%d",lroom->direction_data[3].target_room));
	} else {
		m_door_w.SetWindowText("None");
	}
  if(lroom->direction_data[4].target_room >= 0) {
    m_door_u.SetWindowText(iprintf("%d",lroom->direction_data[4].target_room));
	} else {
		m_door_u.SetWindowText("None");
	}

  if(lroom->direction_data[5].target_room >= 0) {
    m_door_d.SetWindowText(iprintf("%d",lroom->direction_data[5].target_room));
	} else {
		m_door_d.SetWindowText("None");
	}

  if(lroom->direction_data[6].target_room >= 0) {
    m_door_ne.SetWindowText(iprintf("%d",lroom->direction_data[6].target_room));
	} else {
		m_door_ne.SetWindowText("None");
	}

  if(lroom->direction_data[7].target_room >= 0) {
    m_door_nw.SetWindowText(iprintf("%d",lroom->direction_data[7].target_room));
	} else {
		m_door_nw.SetWindowText("None");; 
	}

  if(lroom->direction_data[8].target_room >= 0) {
    m_door_se.SetWindowText(iprintf("%d",lroom->direction_data[8].target_room));
	} else {
		m_door_se.SetWindowText("None");
	}

  if(lroom->direction_data[9].target_room >= 0) {
    m_door_sw.SetWindowText(iprintf("%d",lroom->direction_data[9].target_room));
	} else {
		m_door_sw.SetWindowText("None");
	}

  this->UpdateData(FALSE);
}

extern CDirDialog ourlib;

BOOL Redit::OnSetActive() 
{

	if(theApp.dlg->current_room >= 0) {
		LoadRedit();
	}
	return CPropertyPage::OnSetActive();
}


// This is when the listbox for descript keywords changes because a user selected
// from the listbox.
void Redit::OnSelchangeExdescKeyword() 
{
	vector<Ex_Desc_Data>::const_iterator exd;
	int count;
	extern World the_world;
	extern CCbreakApp theApp;
  Room *lroom;
	int room_vnum= theApp.dlg->current_room;	

  lroom = &(the_world.room_list[room_vnum]);
	count=((CComboBox *) GetDlgItem(IDC_EXDESC_KEYWORD))->GetCurSel();
	
	for(exd=lroom->exdesc.begin();count > 0;count--) {
	  exd++;	
  }
	
	m_exdesc_string=exd->desc.c_str();
	

	UpdateData(FALSE);
}

void Redit::OnRoomNumber() 
{
  JumpToRoom jumper;
	jumper.DoModal();
}

void Redit::OnNextRoom() 
{
	extern CCbreakApp theApp;
  int room_num = theApp.dlg->current_room;
  map<int, Room>::const_iterator ri;

	ri=the_world.room_list.find(room_num);
	if(ri == the_world.room_list.end()) {
		/* this is a serious problem. indicates the current room DNE! */
		error("Uh. The current room doesn't exist?");
	} 
	ri++;
	if(ri == the_world.room_list.end()) {
		ri=the_world.room_list.begin();
  }
	theApp.dlg->current_room = ri->first;

	LoadRedit();

}

void Redit::OnPreviousRoom() 
{
	extern CCbreakApp theApp;
  int room_num = theApp.dlg->current_room;
  map<int, Room>::const_iterator ri;

	ri=the_world.room_list.find(room_num);
	if(ri == the_world.room_list.end()) {
		/* this is a serious problem. indicates the current room DNE! */
		error("Uh. The current room doesn't exist?");
	} 
	if(ri == the_world.room_list.begin()) {
		ri= the_world.room_list.end();
	}
	ri--;
	if(ri == the_world.room_list.end()) {
		ri=the_world.room_list.begin();
  }
	theApp.dlg->current_room = ri->first;

	LoadRedit();
}

void Redit::OnNextZone() 
{
	extern CCbreakApp theApp;
  int room_num = theApp.dlg->current_room;
  map<int,Zone_Data>::const_iterator zi;
  map<int,Room>::const_iterator ri;

	zi = the_world.zone_list.find(the_world.room_list[room_num].zone);
	if(zi==the_world.zone_list.end()) {
		error("Crapbuger. The current zone does not exist.");
	}
  	
	for(ri=the_world.room_list.find(room_num);ri != the_world.room_list.end();ri++) {
  	if(the_world.room_list[ri->first].zone != the_world.room_list[room_num].zone) {
      break;
		}
	}
	if(ri == the_world.room_list.end()) {
		ri=the_world.room_list.begin();
	}

	theApp.dlg->current_room = ri->first;
	this->LoadRedit();
}

void Redit::OnPreviousZone() 
{
 	extern CCbreakApp theApp;
  int room_num = theApp.dlg->current_room;
  map<int,Zone_Data>::const_iterator zi;
  map<int,Room>::const_iterator ri;

	zi = the_world.zone_list.find(the_world.room_list[room_num].zone);
	if(zi==the_world.zone_list.end()) {
		error("Crapbuger. The current zone does not exist.");
	}
  	
	for(ri=the_world.room_list.find(room_num);ri != the_world.room_list.begin();ri--) {
  	if(the_world.room_list[ri->first].zone != the_world.room_list[room_num].zone) {
      break;
		}
	}

	if(ri == the_world.room_list.begin() && the_world.room_list[ri->first].zone ==
			the_world.room_list[room_num].zone) {
		ri=the_world.room_list.end();
		ri--;
	}

	theApp.dlg->current_room = ri->first;
	this->LoadRedit();
}

void Redit::OnNewDesc() 
{
  ExdescAdd exa(0);
	exa.DoModal();
}

void Redit::OnChangeExdescDesc() 
{
	vector<Ex_Desc_Data>::iterator exd;
	int count;
	extern World the_world;
	extern CCbreakApp theApp;
  Room *lroom;
	int room_vnum= theApp.dlg->current_room;	

	UpdateData(TRUE);
  lroom = &(the_world.room_list[room_vnum]);
	count=((CComboBox *) GetDlgItem(IDC_EXDESC_KEYWORD))->GetCurSel();
	
	for(exd=lroom->exdesc.begin();count > 0;count--) {
	  exd++;	
  }
	/* wonder if this will work. Both 'support' to<=>from char * conversions but not
		 work well with others */ 
	exd->desc = m_exdesc_string;

}

void Redit::OnChangeRoomName() 
{
	Room *lroom;

	int room_vnum= theApp.dlg->current_room;
  UpdateData(TRUE);
  lroom = &(the_world.room_list[room_vnum]);
  lroom->name = m_room_name;
}

void Redit::OnEditchangeSectorType() 
{
	Room *lroom;
	int room_vnum= theApp.dlg->current_room;
	m_sector_type = ((CComboBox *) GetDlgItem(IDC_SECTOR_TYPE))->GetCurSel();
  UpdateData(TRUE);
  lroom = &(the_world.room_list[room_vnum]);

	lroom->sector_type = m_sector_type;
}

void Redit::OnChangeEditRoomdesc() 
{
	Room *lroom;

	int room_vnum= theApp.dlg->current_room;
  UpdateData(TRUE);
  lroom = &(the_world.room_list[room_vnum]);

	lroom->description= m_room_description;
	
}


void Redit::OnChangeZoneName() 
{
  Zone_Data *lzone;
  UpdateData(TRUE);

  lzone = &(the_world.zone_list[m_zone_number]);
	lzone->name = m_zone_name;
	
}

void Redit::OnChangeZoneLifespan() 
{
  Zone_Data *lzone;
  UpdateData(TRUE);

  lzone = &(the_world.zone_list[m_zone_number]);
	lzone->lifespan = m_zone_lifespan;
	
}

void Redit::OnEditchangeResetMode() 
{
  Zone_Data *lzone;
  UpdateData(TRUE);

  lzone = &(the_world.zone_list[m_zone_number]);
	lzone->reset_mode = m_reset_mode;	
}

void Redit::OnChangeZoneRange() 
{
  Zone_Data *lzone;
  UpdateData(TRUE);

  lzone = &(the_world.zone_list[m_zone_number]);
	lzone->top = atoi(m_zone_range);
	LoadRedit();
}

void Redit::OnDeleteDesc() 
{
	CString temp;

	Room *lroom;
	int room_vnum= theApp.dlg->current_room;
  lroom = &(the_world.room_list[room_vnum]);
	((CComboBox *) GetDlgItem(IDC_EXDESC_KEYWORD))->GetWindowText(temp);
	lroom->delete_exdata(iprintf("%s",temp));
	LoadRedit();
}

void Redit::OnDoorN() 
{
  EditDoor door(0);
  door.DoModal();
}

void Redit::OnDoorE() 
{
  EditDoor door(1);
  door.DoModal();	
}

void Redit::OnDoorS() 
{
  EditDoor door(2);
  door.DoModal();	
}

void Redit::OnDoorW() 
{
  EditDoor door(3);
  door.DoModal();	
}

void Redit::OnDoorUp() 
{
  EditDoor door(4);
  door.DoModal();
}

void Redit::OnDoorDown() 
{
  EditDoor door(5);
  door.DoModal();	
}

void Redit::OnDoorNe() 
{
  EditDoor door(6);
  door.DoModal();	
}

void Redit::OnDoorNw() 
{
  EditDoor door(7);
  door.DoModal();
}


void Redit::OnDoorSe() 
{
  EditDoor door(8);
  door.DoModal();	
}

void Redit::OnDoorSw() 
{
  EditDoor door(9);
  door.DoModal();
}

void Redit::OnRoomFlags() 
{
  BitvectorSel rf(the_world.room_list[theApp.dlg->current_room].room_flags,"Room Flags");
  rf.DoModal();
  the_world.room_list[theApp.dlg->current_room].room_flags=rf.total;
} 


void Redit::OnSaveRoom() 
{
  int zone = the_world.room_list[theApp.dlg->current_room].zone;
  the_world.save_zone(zone);
    AfxMessageBox("The zone is saved.\n",MB_OK);

}

void Redit::OnDeleteRoom() 
{
  int delroom = theApp.dlg->current_room;

  if(AfxMessageBox("Are you sure you wish to delete this room?",
	  MB_YESNO | MB_APPLMODAL | MB_ICONQUESTION) == IDYES) {
    OnNextRoom();
    the_world.room_list.erase(delroom);
  }		
}

void Redit::OnNewRoom() 
{
  NewRoom nr;
  nr.DoModal();
}

void Redit::disable_redit(int all)
{

  int i;

	for(i=ID_ZONE_NUMBER;i <IDC_ZCMD_SAVE;i++){
		if(GetDlgItem(i)) {
      GetDlgItem(i)->EnableWindow(FALSE);
		}
	}
	if(all == -1) {
		return;
	}
  GetDlgItem(IDC_SAVE_ROOM)->EnableWindow(TRUE);
  GetDlgItem(IDC_NEW_ROOM)->EnableWindow(TRUE);

	if(all == 1) {
  	for(i=ID_ZONE_NUMBER;i <IDC_ZCMD_SAVE;i++){
	  	if(GetDlgItem(i)) {
        GetDlgItem(i)->EnableWindow(TRUE);
			}
		}
	}

}

void Redit::OnGotoZcmds() 
{
  theApp.dlg->m_dlgPropSheet.SetActivePage(1);	
}
